-------------------------------------------------------------------------------
--                 L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local emptyTable = {};

local BATTLE_PET_PSEUDO = "BattlePet-0-P%011X"

-- Info for opponents
local opponentInfo =
{
  {id = 0, name = L["Any Opponent"], zoneId = 0, continentId = 0x0000, iconId = 0, petId = {}},
  {id = 1, name = L["PvP Opponents"], zoneId = 0, continentId = 0x0000, iconId = 0, petId = {}},
  {id = 63194, name = L["Steven Lisbane"], zoneId = 37, continentId = 0x0002, iconId = 63194, petId = {885, 884, 883}},
  {id = 64330, name = L["Julia Stevens"], zoneId = 30, continentId = 0x0002, iconId = 64330, petId = {873, 872}},
  {id = 65648, name = L["Old MacDonald"], zoneId = 39, continentId = 0x0002, iconId = 65648, petId = {876, 875, 874}},
  {id = 65655, name = L["Eric Davidson"], zoneId = 34, continentId = 0x0002, iconId = 65655, petId = {882, 881, 880}},
  {id = 65656, name = L["Bill Buckler"], zoneId = 673, continentId = 0x0002, iconId = 65656, petId = {888, 887, 886}},
  {id = 66126, name = L["Zunta"], zoneId = 4, continentId = 0x0001, iconId = 66126, petId = {890, 889}},
  {id = 66135, name = L["Dagra the Fierce"], zoneId = 11, continentId = 0x0001, iconId = 66135, petId = {893, 892, 891}},
  {id = 66136, name = L["Analynn"], zoneId = 43, continentId = 0x0001, iconId = 66136, petId = {896, 895, 894}},
  {id = 66137, name = L["Zonya the Sadist"], zoneId = 81, continentId = 0x0001, iconId = 66137, petId = {899, 898, 897}},
  {id = 66352, name = L["Traitor Gluk"], zoneId = 121, continentId = 0x0001, iconId = 66352, petId = {906, 905, 904}},
  {id = 66372, name = L["Merda Stronghoof"], zoneId = 101, continentId = 0x0001, iconId = 66372, petId = {902, 901, 900}},
  {id = 66412, name = L["Elena Flutterfly"], zoneId = 241, continentId = 0x0001, iconId = 66412, petId = {926, 925, 924}},
  {id = 66422, name = L["Cassandra Kaboom"], zoneId = 607, continentId = 0x0001, iconId = 66422, petId = {909, 908, 907}},
  {id = 66436, name = L["Grazzle the Great"], zoneId = 141, continentId = 0x0001, iconId = 66436, petId = {913, 912, 911}},
  {id = 66442, name = L["Zoltan"], zoneId = 182, continentId = 0x0001, iconId = 66442, petId = {923, 922, 921}},
  {id = 66452, name = L["Kela Grimtotem"], zoneId = 61, continentId = 0x0001, iconId = 66452, petId = {917, 916, 915}},
  {id = 66466, name = L["Stone Cold Trixxy"], zoneId = 281, continentId = 0x0001, iconId = 66466, petId = {929, 928, 927}},
  {id = 66478, name = L["David Kosse"], zoneId = 26, continentId = 0x0002, iconId = 66478, petId = {933, 932, 931}},
  {id = 66512, name = L["Deiza Plaguehorn"], zoneId = 23, continentId = 0x0002, iconId = 66512, petId = {936, 935, 934}},
  {id = 66515, name = L["Kortas Darkhammer"], zoneId = 28, continentId = 0x0002, iconId = 66515, petId = {939, 938, 937}},
  {id = 66518, name = L["Everessa"], zoneId = 38, continentId = 0x0002, iconId = 66518, petId = {943, 942, 941}},
  {id = 66520, name = L["Durin Darkhammer"], zoneId = 29, continentId = 0x0002, iconId = 66520, petId = {946, 945, 944}},
  {id = 66522, name = L["Lydia Accoste"], zoneId = 32, continentId = 0x0002, iconId = 66522, petId = {949, 948, 947}},
  {id = 66550, name = L["Nicki Tinytech"], zoneId = 465, continentId = 0x0004, iconId = 66550, petId = {952, 951, 950}},
  {id = 66551, name = L["Ras'an"], zoneId = 467, continentId = 0x0004, iconId = 66551, petId = {955, 954, 953}},
  {id = 66552, name = L["Narrok"], zoneId = 477, continentId = 0x0004, iconId = 66552, petId = {958, 957, 956}},
  {id = 66553, name = L["Morulu The Elder"], zoneId = 481, continentId = 0x0004, iconId = 66553, petId = {961, 960, 959}},
  {id = 66557, name = L["Bloodknight Antari"], zoneId = 473, continentId = 0x0004, iconId = 66557, petId = {964, 963, 962}},
  {id = 66635, name = L["Beegle Blastfuse"], zoneId = 491, continentId = 0x0008, iconId = 66635, petId = {967, 966, 965}},
  {id = 66636, name = L["Nearly Headless Jacob"], zoneId = 510, continentId = 0x0008, iconId = 66636, petId = {970, 969, 968}},
  {id = 66638, name = L["Okrut Dragonwaste"], zoneId = 488, continentId = 0x0008, iconId = 66638, petId = {973, 972, 971}},
  {id = 66639, name = L["Gutretch"], zoneId = 496, continentId = 0x0008, iconId = 66639, petId = {976, 975, 974}},
  {id = 66675, name = L["Major Payne"], zoneId = 492, continentId = 0x0008, iconId = 66675, petId = {979, 978, 977}},
  {id = 66730, name = L["Hyuna of the Shrines"], zoneId = 806, continentId = 0x0020, iconId = 66730, petId = {994, 993, 992}},
  {id = 66733, name = L["Mo'ruk"], zoneId = 857, continentId = 0x0020, iconId = 66733, petId = {998, 1000, 999}},
  {id = 66734, name = L["Farmer Nishi"], zoneId = 807, continentId = 0x0020, iconId = 66734, petId = {997, 996, 995}},
  {id = 66738, name = L["Courageous Yon"], zoneId = 809, continentId = 0x0020, iconId = 66738, petId = {1003, 1002, 1001}},
  {id = 66739, name = L["Wastewalker Shu"], zoneId = 858, continentId = 0x0020, iconId = 66739, petId = {1009, 1008, 1007}},
  {id = 66741, name = L["Aki the Chosen"], zoneId = 811, continentId = 0x0020, iconId = 66741, petId = {1012, 1011, 1010}},
  {id = 66815, name = L["Bordin Steadyfist"], zoneId = 640, continentId = 0x0010, iconId = 66815, petId = {985, 984, 983}},
  {id = 66819, name = L["Brok"], zoneId = 606, continentId = 0x0001, iconId = 66819, petId = {982, 981, 980}},
  {id = 66822, name = L["Goz Banefury"], zoneId = 700, continentId = 0x0002, iconId = 66822, petId = {988, 987, 986}},
  {id = 66824, name = L["Obalis"], zoneId = 720, continentId = 0x0001, iconId = 66824, petId = {991, 990, 989}},
  {id = 66918, name = L["Seeker Zusshi"], zoneId = 810, continentId = 0x0020, iconId = 66918, petId = {1006, 1005, 1004}},
  {id = 67370, name = L["Jeremy Feasel"], zoneId = 823, continentId = 0x0010, iconId = 67370, petId = {1065, 1067, 1066}},
  {id = 68462, name = L["Flowing Pandaren Spirit"], zoneId = 858, continentId = 0x0020, iconId = 1138, petId = {1132, 1133, 1138}},
  {id = 68463, name = L["Burning Pandaren Spirit"], zoneId = 810, continentId = 0x0020, iconId = 1139, petId = {1130, 1139, 1131}},
  {id = 68464, name = L["Whispering Pandaren Spirit"], zoneId = 806, continentId = 0x0020, iconId = 1140, petId = {1135, 1136, 1140}},
  {id = 68465, name = L["Thundering Pandaren Spirit"], zoneId = 809, continentId = 0x0020, iconId = 1141, petId = {1141, 1134, 1137}},
  {id = 68555, name = 0, zoneId = 806, continentId = 0x0020, iconId = -1, petId = {1129}},
  {id = 68558, name = 0, zoneId = 858, continentId = 0x0020, iconId = -1, petId = {1187}},
  {id = 68559, name = 0, zoneId = 811, continentId = 0x0020, iconId = -1, petId = {1188}},
  {id = 68560, name = 0, zoneId = 807, continentId = 0x0020, iconId = -1, petId = {1189}},
  {id = 68561, name = 0, zoneId = 807, continentId = 0x0020, iconId = -1, petId = {1190}},
  {id = 68562, name = 0, zoneId = 810, continentId = 0x0020, iconId = -1, petId = {1191}},
  {id = 68563, name = 0, zoneId = 809, continentId = 0x0020, iconId = -1, petId = {1192}},
  {id = 68564, name = 0, zoneId = 809, continentId = 0x0020, iconId = -1, petId = {1193}},
  {id = 68565, name = 0, zoneId = 806, continentId = 0x0020, iconId = -1, petId = {1194}},
  {id = 68566, name = 0, zoneId = 857, continentId = 0x0020, iconId = -1, petId = {1195}},
  {id = 71924, name = L["Wrathion"], zoneId = 955, continentId = 0x0020, iconId = 71924, petId = {1299, 1301, 1300}},
  {id = 71926, name = L["Lorewalker Cho"], zoneId = 955, continentId = 0x0020, iconId = 71926, petId = {1285, 1284, 1283}},
  {id = 71927, name = L["Chen Stormstout"], zoneId = 955, continentId = 0x0020, iconId = 71927, petId = {1282, 1281, 1280}},
  {id = 71929, name = L["Sully \"The Pickle\" McLeary"], zoneId = 955, continentId = 0x0020, iconId = 71929, petId = {1291, 1289, 1290}},
  {id = 71930, name = L["Shademaster Kiryn"], zoneId = 955, continentId = 0x0020, iconId = 71930, petId = {1288, 1287, 1286}},
  {id = 71931, name = L["Taran Zhu"], zoneId = 955, continentId = 0x0020, iconId = 71931, petId = {1295, 1293, 1292}},
  {id = 71932, name = L["Wise Mari"], zoneId = 955, continentId = 0x0020, iconId = 71932, petId = {1296, 1298, 1297}},
  {id = 71933, name = L["Blingtron 4000"], zoneId = 955, continentId = 0x0020, iconId = 71933, petId = {1278, 1279, 1277}},
  {id = 71934, name = L["Dr. Ion Goldbloom"], zoneId = 955, continentId = 0x0020, iconId = 71934, petId = {1269, 1271, 1268}},
  {id = 72009, name = 0, zoneId = 955, continentId = 0x0020, iconId = -1, petId = {1267}},
  {id = 72285, name = 0, zoneId = 955, continentId = 0x0020, iconId = -1, petId = {1311}},
  {id = 72290, name = 0, zoneId = 955, continentId = 0x0020, iconId = -1, petId = {1319}},
  {id = 72291, name = 0, zoneId = 955, continentId = 0x0020, iconId = -1, petId = {1317}},
  {id = 79179, name = L["Squirt"], zoneId = 971, continentId = 0x0040, iconId = 79179, petId = {1400, 1401, 1402}},
  {id = 79751, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1409}},
  {id = 83837, name = L["Cymre Brightblade"], zoneId = 949, continentId = 0x0040, iconId = 83837, petId = {1443, 1444, 1424}},
  {id = 85519, name = L["Christoph VonFeasel"], zoneId = 823, continentId = 0x0010, iconId = 85519, petId = {1477, 1476, 1475}},
  {id = 85561, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1479, 1482}},
  {id = 85650, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1480}},
  {id = 85656, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1483, 1484, 1485}},
  {id = 85659, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1486}},
  {id = 85660, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1488, 1487}},
  {id = 85662, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1489, 1490}},
  {id = 85664, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1492, 1494, 1493}},
  {id = 85674, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1496, 1497, 1498}},
  {id = 85677, name = 0, zoneId = 976, continentId = 0x0040, iconId = -1, petId = {1500, 1499}},
  {id = 85679, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1501, 1502, 1503}},
  {id = 85682, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1504, 1505, 1506}},
  {id = 85685, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1507}},
  {id = 85686, name = 0, zoneId = 971, continentId = 0x0040, iconId = -1, petId = {1508, 1509, 1510}},
  {id = 87110, name = L["Tarr the Terrible"], zoneId = 950, continentId = 0x0040, iconId = 87110, petId = {1555, 1554, 1556}},
  {id = 87122, name = L["Gargra"], zoneId = 941, continentId = 0x0040, iconId = 87122, petId = {1550, 1552, 1553}},
  {id = 87123, name = L["Vesharr"], zoneId = 948, continentId = 0x0040, iconId = 87123, petId = {1558, 1559, 1557}},
  {id = 87124, name = L["Ashlei"], zoneId = 947, continentId = 0x0040, iconId = 87124, petId = {1547, 1548, 1549}},
  {id = 87125, name = L["Taralune"], zoneId = 946, continentId = 0x0040, iconId = 87125, petId = {1560, 1561, 1562}},
  {id = 94601, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94601, petId = {1671}},
  {id = 94637, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94637, petId = {1673}},
  {id = 94638, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94638, petId = {1674}},
  {id = 94639, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94639, petId = {1675}},
  {id = 94640, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94640, petId = {1676}},
  {id = 94641, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94641, petId = {1677}},
  {id = 94642, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94642, petId = {1678}},
  {id = 94643, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94643, petId = {1679}},
  {id = 94644, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94644, petId = {1680}},
  {id = 94645, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94645, petId = {1681}},
  {id = 94646, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94646, petId = {1682}},
  {id = 94647, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94647, petId = {1683}},
  {id = 94648, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94648, petId = {1684}},
  {id = 94649, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94649, petId = {1685}},
  {id = 94650, name = 0, zoneId = 945, continentId = 0x0040, iconId = 94650, petId = {1686}},
};

-- Mapping from opponent ID to info
local opponentById =
{
  [85655] = 85561,
  [85657] = 85656,
  [85658] = 85656,
  [85661] = 85660,
  [85663] = 85662,
  [85665] = 85664,
  [85666] = 85664,
  [85675] = 85674,
  [85676] = 85674,
  [85678] = 85677,
  [85680] = 85679,
  [85681] = 85679,
  [85683] = 85682,
  [85684] = 85682,
  [85687] = 85686,
  [85688] = 85686,
};

local loadOutPlaceholders = {};

-------------------------------------------------------------------------------
--                 A  D  D  O  N     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

-- Automatically caches the info for each species interrogated
L.petSpecies = setmetatable({},
{
  __index = function(table, key)
    table[key] = {};
    table[key].name, table[key].icon, table[key].type =
      C_PetJournal.GetPetInfoBySpeciesID(key);
    table[key].id, table[key].level =
      C_PetJournal.GetPetAbilityList(key);

    return table[key];
  end
});

-------------------------------------------------------------------------------
--                 L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function hooked into 'C_PetJournal.SetPetLoadOutInfo". It hides placeholder
-- frames for any slot a pet has been loaded into.
--
local function petLoadOutOnChange(slotIdx, petGuid)
  -- Hide the placeholder frames, if required
  for slotIdx = 1, L.MAX_ACTIVE_PETS do
    if ((loadOutPlaceholders[slotIdx] ~= nil) and
        (loadOutPlaceholders[slotIdx].guid ~=
          C_PetJournal.GetPetLoadOutInfo(slotIdx))) then
      loadOutPlaceholders[slotIdx]:Hide();
      loadOutPlaceholders[slotIdx].guid = nil;
    end
  end

  return;
end

--
-- Function to compare two pet teams for use with 'table.sort'
--
local function petTeamsCompare(first, second)
  -- Check if the pet teams have the same name
  if (first.name == second.name) then
    -- Check if the pet teams have the same opponent
    if (first.opponentId-second.opponentId == 0) then
      return (first.editTime > second.editTime);
    else
      return (opponentById[first.opponentId].name <
               opponentById[second.opponentId].name);
    end
  end

  -- Compare the team names and opponents
  if ((first.name ~= "") and (second.name ~= "")) then
    return first.name < second.name;
  elseif ((first.name ~= "") and (second.name == "")) then
    if (second.opponentId > 0) then
      return first.name < opponentById[second.opponentId].name;
    else
      return true;
    end
  elseif ((first.name == "") and (second.name ~= "")) then
    if (first.opponentId > 0) then
      return opponentById[first.opponentId].name < second.name;
    else
      return false;
    end
  end

  -- Force an error
  assert(false, "Unhandled pet team comparison.");
  return false;
end

--
-- Function to find the index of a value within a table
--
local function tIndex(table, value)
  -- Local Variables
  local index = nil;

  -- Search the table for the specified value
  for tableIdx, tableValue in ipairs(table) do
    if (tableValue == value) then
      index = tableIdx;
      break;
    end
  end

  return index;
end

-------------------------------------------------------------------------------
--                 A  D  D  O  N     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to get info about a pet from its GUID. The function first checks
-- if the info is available from the Pet Journal. If it isn't it then checks
-- the 'pets' table from the addon's saved variables. This allows info for
-- missing pets to be displayed.
--
L.petGetInfo = function(petGuid)
  -- Local Variables
  local health;
  local iterator;
  local level;
  local maxHealth;
  local power;
  local quality;
  local speciesId;
  local speed;
  local isAvailable = false;
  local customName;

  -- Check a pet GUID has been specified
  if (type(petGuid) == "string") then
    -- Try to get the pet's info from the Pet Journal
    speciesId, customName, level = C_PetJournal.GetPetInfoByPetID(petGuid);
    if (speciesId ~= nil) then
      health, maxHealth, power, speed, quality =
        C_PetJournal.GetPetStats(petGuid);
      isAvailable = true;
    elseif (NglPtDB.pets[petGuid] ~= nil) then
      iterator  = string.gmatch(NglPtDB.pets[petGuid], "[^|]+");
      speciesId = tonumber(iterator());
      level     = tonumber(iterator());
      maxHealth = tonumber(iterator());
      health    = maxHealth;
      power     = tonumber(iterator());
      speed     = tonumber(iterator());
      quality   = tonumber(iterator());
    end
  end

  return speciesId, customName, level, health, maxHealth, power, speed,
    quality, isAvailable;
end

--
-- Function to save the info for a pet to the 'pets' table in the addon's
-- saved variables. This info can then be used to display details of the pet
-- even if it is no longer in the Pet Journal, to aid in finding a replacement.
--
L.petSaveInfo = function(petGuid)
  -- Get the info to be saved for the pet
  local speciesId, _, level = C_PetJournal.GetPetInfoByPetID(petGuid);
  local _, maxHealth, power, speed, quality =
    C_PetJournal.GetPetStats(petGuid);

  -- Add the pet's info to the 'pets' table
  if ((type(level) == "number") and (type(quality) == "number")) then
    NglPtDB.pets[petGuid] = speciesId.."|"..level.."|"..maxHealth.."|"..
      power.."|"..speed.."|"..quality;
  end

  return;
end

--
-- Function to save info for a pet that doesn't exist in the player's pet
-- journal in a way that can't conflict with any new pets the player obtains.
--
L.petSavePseudoInfo = function(speciesId, level, maxHealth, power, speed, quality)
  -- Local Variables
  local petGuid;
  local pets = NglPtDB.pets;

  -- Search for a free pseudo GUID
  for idx = 1, 0xFFFF do
    petGuid = format(BATTLE_PET_PSEUDO, idx);
    if (pets[petGuid] == nil) then
      break;
    end
  end

  -- Check a free pseudo GUID was found
  if (pets[petGuid] == nil) then
    -- Add the pet's info to the 'pets' table
    pets[petGuid] = speciesId.."|"..level.."|"..maxHealth.."|"..
      power.."|"..speed.."|"..quality;
  end

  return petGuid;
end

--
-- Function to update the info in the 'pets' table
--
L.petsUpdateInfo = function()
  -- Local Variables
  local isUsed = {};
  local petGuid;

  -- Create a list of all the pets used in pet teams
  for _, petTeam in ipairs(NglPtDB.petTeams) do
    for _, petInfo in ipairs(petTeam.pets) do
      if (petInfo.guid ~= nil) then
        isUsed[petInfo.guid] = true;
      end
    end
  end

  -- Remove any unused pets from the list
  for petGuid, _ in pairs(NglPtDB.pets) do
    if (not isUsed[petGuid]) then
      NglPtDB.pets[petGuid] = nil;
    end
  end

  -- Update the info for the pets in the list
  for petGuid, _ in pairs(isUsed) do
    L.petSaveInfo(petGuid);
  end

  return;
end

--
-- Function to find the FIRST team that matches the current opponent and
-- load out.
--
function L.petTeamByCurrentBattle()
  -- Local Variables
  local current;
  local isMatch;
  local loadOutPets = {{abilityId = {}}, {abilityId = {}}, {abilityId = {}}};
  local opponentId;
  local teamInfo;

  -- Work out the current opponent from the pet species
  opponentId = L.petTeamOpponentByPetSpecies(
    C_PetBattles.GetPetSpeciesID(2, 1),
    C_PetBattles.GetPetSpeciesID(2, 2),
    C_PetBattles.GetPetSpeciesID(2, 3));
  if (opponentId ~= nil) then
    -- Get info for the current pets
    for petIdx = 1, L.MAX_ACTIVE_PETS do
      current = loadOutPets[petIdx];
      current.guid, current.abilityId[1], current.abilityId[2],
        current.abilityId[3] = C_PetJournal.GetPetLoadOutInfo(petIdx);
    end

    -- Check each pet team against the current opponent and load out
    for teamIdx = 1, #NglPtDB.petTeams do
      -- Check the team's opponent matches the current opponent
      current = NglPtDB.petTeams[teamIdx];
      if (current.opponentId == opponentId) then
        -- Check each pet in the pet team matches the load out
        isMatch = true;
        for petIdx = 1, L.MAX_ACTIVE_PETS do
          if (current.pets[petIdx].guid ~= nil) then
            -- Check if the GUID match
            if (current.pets[petIdx].guid ~= loadOutPets[petIdx].guid) then
              isMatch = false;
              break;
            end

            -- Check if the abilities in each slot match
            for abilityIdx = 1, L.NUM_ACTIVE_ABILITIES do
              if (current.pets[petIdx].abilityId[abilityIdx] ~=
                  loadOutPets[petIdx].abilityId[abilityIdx]) then
                isMatch = false;
                break;
              end
            end
          end
        end

        -- Check if the pet team is a match
        if (isMatch) then
          teamInfo = current;
          break;
        end
      end
    end
  end

  return teamInfo;
end

--
-- Function to copy the info for a pet team from one table to another
--
L.petTeamCopy = function(src, dest)
  -- Initialise the source and destination tables for the pet team
  src  = src or emptyTable;
  dest = dest or {};

  -- Copy the pet team info from the source to destination table
  dest.name       = src.name       or "";
  dest.opponentId = src.opponentId or 0;
  dest.iconPathId = src.iconPathId or 0;
  dest.strategy   = src.strategy   or "";
  dest.isHtml     = src.isHtml     or false;
  dest.editTime   = src.editTime   or 0;
  dest.editPatch  = src.editPatch  or "";
  dest.pets       = dest.pets      or {};
  for idx = 1, L.MAX_ACTIVE_PETS do
    dest.pets[idx] = L.petTeamPetCopy(
      (src.pets ~= nil and src.pets[idx] or nil), dest.pets[idx]);
  end

  -- Make sure all string values are valid lengths
  if (string.len(dest.name) > L.MAX_TEAM_NAME_LEN) then
    dest.name = string.sub(dest.name, 1, L.MAX_TEAM_NAME_LEN);
  end
  if (string.len(dest.strategy) > L.MAX_TEAM_STRAT_LEN) then
    dest.strategy = string.sub(dest.strategy, 1, L.MAX_TEAM_STRAT_LEN);
  end

  return dest;
end

--
-- Function to delete a pet team
--
function L.petTeamDelete(teamInfo)
  -- Delete the pet team from the list
  tDeleteItem(NglPtDB.petTeams, teamInfo);

  return;
end

--
-- Function to load a pet team
--
function L.petTeamLoad(teamInfo)
  -- Local Variables
  local _;
  local cpj = C_PetJournal;
  local lvlIdx = 1;
  local lvlPets = {};
  local numLvlPets = 0;
  local petGuid;
  local petLevel;
  local speciesId;
  local speciesInfo;

  -- Get the GUID of any levelling pets currently in the load out
  for slotIdx, petInfo in ipairs(teamInfo.pets) do
    petGuid = cpj.GetPetLoadOutInfo(slotIdx, petInfo.guid);
    if (petGuid ~= nil) then
      _, _, petLevel = C_PetJournal.GetPetInfoByPetID(petGuid);
      if ((petLevel ~= nil) and (petLevel < 25)) then
        numLvlPets = numLvlPets+1;
        lvlPets[numLvlPets] = {guid = petGuid, level = petLevel};
      end
    end
  end

  -- Sort the levelling pets by level
  if (numLvlPets > 1) then
    table.sort(lvlPets,
      function(first, second)
        return first.level < second.level;
      end);
  end

  -- Load each pet in the team into the correct slot
  for slotIdx, petInfo in ipairs(teamInfo.pets) do
    -- Check the pet specified for the slot is valid
    speciesId   = L.petGetInfo(petInfo.guid);
    speciesInfo = (speciesId ~= nil and L.petSpecies[speciesId] or nil);
    if (petInfo.guid ~= nil) then
      if ((speciesInfo ~= nil) and
          (cpj.GetPetInfoByPetID(petInfo.guid) ~= nil)) then
        -- Put the pet in the slot
        cpj.SetPetLoadOutInfo(slotIdx, petInfo.guid);

        -- Set the pet's abilities
        for abilityIdx, abilityId in ipairs(petInfo.abilityId) do
          if ((speciesInfo.id[abilityIdx                       ] ==
                abilityId) or
              (speciesInfo.id[abilityIdx+L.NUM_ACTIVE_ABILITIES] ==
                abilityId)) then
            cpj.SetAbility(slotIdx, abilityIdx, abilityId);
          end
        end
      end
    elseif (lvlIdx <= numLvlPets) then
      cpj.SetPetLoadOutInfo(slotIdx, lvlPets[lvlIdx].guid);
      lvlIdx = lvlIdx+1;
    end

    -- Create the placeholder frame, if required
    if ((petInfo.guid == nil) and
        (loadOutPlaceholders[slotIdx] == nil) and
        (_G["PetJournalLoadoutPet"..slotIdx] ~= nil)) then
      loadOutPlaceholders[slotIdx] = CreateFrame("Frame", nil,
        _G["PetJournalLoadoutPet"..slotIdx],
        "NigglesPetTeamsPlaceholderTemplate");
    end

    -- Show/hide the placeholder frame
    if (loadOutPlaceholders[slotIdx] ~= nil) then
      loadOutPlaceholders[slotIdx]:SetShown(petInfo.guid == nil);
      loadOutPlaceholders[slotIdx].guid = cpj.GetPetLoadOutInfo(slotIdx);
    end
  end

  -- Update the pet journal's load out
  PetJournal_UpdatePetLoadOut();

  return;
end

--
-- Function to get info for an opponent by NPC ID
--
function L.petTeamOpponentById(id)
  -- Check if an opponent with the specified NPC ID is known
  if (opponentById[id] ~= nil) then
    -- NOTE: The ID is returned as the 2nd argument, rather than the first,
    --       because the name is required far more often.
    local current = opponentById[id];
    return current.name, current.id, current.zoneId, current.continentId;
  else
    return nil;
  end
end

--
-- Function to get info for an opponent by index
--
function L.petTeamOpponentByIndex(idx)
  -- Check if an opponent with the specified NPC ID is known
  if (opponentInfo[idx] ~= nil) then
    local current = opponentInfo[idx];
    return current.id, current.name, current.zoneId, current.continentId;
  else
    return nil;
  end
end

--
-- Function to get info for an opponent by the species of the specified pets
--
function L.petTeamOpponentByPetSpecies(...)
  -- Local Variables
  local opponentId;
  local opponentPetInfo;
  local petSpecies = {...};
  local numMatches;

  -- Search all the opponents for one with the specified pet species
  for opponentIdx = 1, #opponentInfo do
    -- Check the current opponent isn't 'Any Opponent'
    if (opponentInfo[opponentIdx].id > 0) then
      -- Compare the opponent's pets to the specified list
      opponentPetInfo = opponentInfo[opponentIdx].petId
      numMatches = 0;
      for petIdx = 1, L.MAX_ACTIVE_PETS do
        if ((opponentPetInfo[petIdx] ~= nil) and
            (opponentPetInfo[petIdx] == petSpecies[petIdx])) then
          numMatches = numMatches+1;
        end
      end

      -- Check if all the opponent's pets match the specified list
      if ((numMatches > 0) and (numMatches == #opponentPetInfo)) then
        opponentId = opponentInfo[opponentIdx].id;
        break;
      end
    end
  end

  return opponentId;
end

--
-- Function to get the number of opponents
--
function L.petTeamOpponentCount()
  return #opponentInfo;
end

--
-- Function to get the icons for an opponent.
--
function L.petTeamOpponentIconById(id, idx)
  -- Local Variables
  local iconId = nil;
  local opponent = opponentById[id];

  -- Check the opponent ID is valid
  if (opponent ~= nil) then
    if (idx == 1) then
      iconId = (opponent.iconId >= 0 and opponent.iconId or opponent.petId[1]);
    elseif ((idx >= 2) and (idx <= 4)) then
      iconId = opponent.petId[idx-1];
    end
  end

  return iconId;
end

--
-- Function to copy the info for a pet from one table to another
--
function L.petTeamPetCopy(src, dest)
  -- Initialise the source and destination tables for the pet
  src  = src or emptyTable;
  dest = dest or {};

  -- Copy the pet info from the source to destination table
  dest.guid      = src.guid;
  dest.abilityId = dest.abilityId or {};
  for idx = 1, L.NUM_ACTIVE_ABILITIES do
    dest.abilityId[idx] = (src.abilityId ~= nil and src.abilityId[idx] or nil);
  end

  return dest;
end

--
-- Function to save a pet team
--
function L.petTeamSave(newInfo, newStrategy, teamInfo)
  -- Local Variables
  local petTeams = NglPtDB.petTeams;

  -- Save the pet team
  if (teamInfo == nil) then
    petTeams[#petTeams+1] = {};
    teamInfo = petTeams[#petTeams];
  end
  L.petTeamCopy(newInfo, teamInfo);

  -- Save the edit time and patch
  teamInfo.editTime  = time();
  teamInfo.editPatch = L.buildGetNumber();

  -- Save info for the pet team's pets, for use if the pet is caged/released
  for _, petInfo in ipairs(teamInfo.pets) do
    if (petInfo.guid ~= nil) then
      L.petSaveInfo(petInfo.guid);
    end
  end

  -- Save the team's strategy
  teamInfo.strategy = newStrategy;

  return teamInfo;
end

--
-- Function to check if there is an identical pet team to the specified one,
-- ignoring another team so an existing pet team being edited can be skipped.
--
function L.petTeamsHaveIdentical(teamInfo, ignoreTeam)
  -- Local Variables
  local current;
  local haveIdentical = false;
  local isIdentical;
  local petTeams = NglPtDB.petTeams;

  -- Check each pet team to see if it is identical to the specified team
  for teamIdx = 1, #petTeams do
    -- Set the flag that indicates if the pet teams are identical
    isIdentical = true;

    -- Compare the general info for the teams
    current = petTeams[teamIdx];
    if ((current.name       ~= teamInfo.name      ) or
        (current.opponentId ~= teamInfo.opponentId) or
        (current.strategy   ~= teamInfo.strategy  ) or
        (current.isHtml     ~= teamInfo.isHtml    )) then
      isIdentical = false;
    else
      -- Compare the pets for the teams
      for petIdx = 1, L.MAX_ACTIVE_PETS do
        if (current.pets[petIdx].guid ~= teamInfo.pets[petIdx].guid)  then
          isIdentical = false;
        elseif (current.pets[petIdx].guid ~= nil)  then
          -- Compare the abilities for the pets
          for abilityIdx = 1, L.NUM_ACTIVE_ABILITIES do
            if (current.pets[petIdx].abilityId[abilityIdx] ~=
                 teamInfo.pets[petIdx].abilityId[abilityIdx]) then
              isIdentical = false;
              break;
            end
          end
        end
      end
    end

    -- Check if the current pet team is a match for the specified pet team
    if ((isIdentical) and (current ~= ignoreTeam)) then
      haveIdentical = true;
      break;
    end
  end

  return haveIdentical;
end

--
-- Function to initialise the pet team software
--
L.petTeamsInit = function()
  -- Local Variables
  local _;
  local abilityIdx;
  local cpjGetPetInfoBySpeciesID = C_PetJournal.GetPetInfoBySpeciesID;
  local currentPatch = L.buildGetNumber();
  local currentTime = time();
  local index;
  local numPets;
  local numValid;
  local petInfo;
  local petLevel;
  local petSpeciesId;
  local speciesInfo;
  local validAbilities = {};

  -- Initialise the opponent info
  for _, opponent in pairs(opponentInfo) do
    -- Create the opponent's name, if derived from the pets
    if (opponent.name == 0) then
      numPets = #opponent.petId;
      opponent.name = format("%s%s%s%s%s",
        (numPets >= 1 and cpjGetPetInfoBySpeciesID(opponent.petId[1]) or ""),
        ((numPets == 3) and ", " or ((numPets == 2) and " & " or "")),
        (numPets >= 2 and cpjGetPetInfoBySpeciesID(opponent.petId[2]) or ""),
        ((numPets == 3) and " & " or ""),
        (numPets >= 3 and cpjGetPetInfoBySpeciesID(opponent.petId[3]) or ""));
    end

    -- Add the opponent to the list of IDs
    opponentById[opponent.id] = opponent;
  end

  -- Assign the correct opponent info to those opponents without a pet tamer
  for opponentId, opponentInfo in pairs(opponentById) do
    if (type(opponentInfo) == "number") then
      opponentById[opponentId] = opponentById[opponentInfo];
    end
  end

  -- Sort the opponents by name
  table.sort(opponentInfo,
    function(first, second)
      if ((first.id <= 1) or (second.id <= 1)) then
        return (first.id < second.id);
      else
        return (first.name < second.name);
      end
    end);

  -- Update the info stored for pets used in teams
  L.petsUpdateInfo();

  -- Validate the info for each team
  for _, teamInfo in ipairs(NglPtDB.petTeams) do
    -- Validate the opponent ID
    if (opponentById[teamInfo.opponentId] == nil) then
      teamInfo.opponentId = 0;
    end

    -- Validate the team name
    teamInfo.name = (teamInfo.name or
      ((teamInfo.opponentId == 0) and L["Unnamed Team"] or ""));
    if (string.len(teamInfo.name) > L.MAX_TEAM_NAME_LEN) then
      teamInfo.name = string.sub(teamInfo.name, 1, L.MAX_TEAM_NAME_LEN);
    end

    -- Validate the strategy
    teamInfo.isHtml = (teamInfo.isHtml or false);
    if (teamInfo.strategy == nil) then
      teamInfo.strategy = "";
    elseif (string.len(teamInfo.strategy) > L.MAX_TEAM_STRAT_LEN) then
      teamInfo.strategy = string.sub(teamInfo.strategy, 1,
        L.MAX_TEAM_STRAT_LEN);
    end

    -- Validate the edit time
    if ((teamInfo.editTime == nil) or
        (teamInfo.editTime > currentTime)) then
      teamInfo.editTime  = currentTime;
      teamInfo.editPatch = currentPatch;
    elseif (type(teamInfo.editPatch) == "string") then
      -- TODO: Remove when not likely to be needed any more
      teamInfo.editPatch = L.buildGetNumber(teamInfo.editPatch);
    end

    -- Validate the pets
    for petIdx = 1, L.MAX_ACTIVE_PETS do
      -- Check the pet's entry is the correct type
      if (type(teamInfo.pets[petIdx]) ~= "table") then
        teamInfo.pets[petIdx] = L.petTeamPetCopy(nil);
      end

      -- Get info about the pet and its species
      petInfo = teamInfo.pets[petIdx];
      if (petInfo.guid ~= nil) then
        petSpeciesId, _, petLevel = L.petGetInfo(petInfo.guid);
        speciesInfo = (petSpeciesId ~= nil and
          L.petSpecies[petSpeciesId] or nil);
      end

      -- Check the pet's info could be obtained
      if ((petInfo.guid ~= nil) and (speciesInfo  ~= nil)) then
        -- NOTE: The following code is to handle pet abilities being moved
        --       by Blizzard, which has happened in the past, or a pet being
        --       de-levelled by it's quality being upgraded.

        -- Check which selected abilities are valid, based on species and level
        numValid = 0;
        for slotIdx = 1, L.NUM_ACTIVE_ABILITIES do
          index = tIndex(speciesInfo.id, petInfo.abilityId[slotIdx]);
          if ((index ~= nil) and (speciesInfo.level[index] <= petLevel)) then
            numValid = numValid+1;
            validAbilities[numValid] = petInfo.abilityId[slotIdx];
          end
        end

        -- Re-initialise selected abilities in their current slot
        abilityIdx = L.NUM_ACTIVE_ABILITIES+1;
        for slotIdx = 1, L.NUM_ACTIVE_ABILITIES do
          index = tIndex(validAbilities, speciesInfo.id[abilityIdx]);
          if ((index ~= nil) and (index <= numValid)) then
            petInfo.abilityId[slotIdx] = speciesInfo.id[abilityIdx];
          else
            petInfo.abilityId[slotIdx] = speciesInfo.id[slotIdx];
          end
          abilityIdx = abilityIdx+1;
        end
      else
        -- Remove the invalid pet
        teamInfo.pets[petIdx] = L.petTeamPetCopy(nil);
      end
    end
  end

  -- Sort the pet teams
  L.petTeamsSort();

  -- Hook the function used to change the load out
  hooksecurefunc(C_PetJournal, "SetPetLoadOutInfo", petLoadOutOnChange);

  return;
end

--
-- Function to sort the pet teams by name and opponent
--
L.petTeamsSort = function()
  -- Sort the pet teams
  table.sort(NglPtDB.petTeams, petTeamsCompare);
  return;
end
